#include "chromosome.h"
#include <stdlib.h>
#include <float.h>


chromosome::chromosome(void)
{
}

chromosome::~chromosome(void)
{
}
chromosome::chromosome(vector<double> new_genes, int new_id, int new_gen)
{
	id = new_id;
	gen = new_gen;
	genes = new_genes;
	fitness = 0;
}
vector<double> chromosome::getGenes()
{
	return genes;
}
void chromosome::setGenes(std::vector<double> new_genes)
{
	genes = new_genes;
}
double chromosome::getFitness()
{
	return fitness;
}
void chromosome::setFitness(double new_fitness)
{
	fitness = new_fitness;
}
void chromosome::mutate(double prob, double mean, double deviation)
{
	
	for(unsigned int i = 0; i < genes.size(); i++)
	{
		double random = ((double)rand()) / (RAND_MAX+1);
		if(random < prob)
		{
			double r1 = (double)rand()/RAND_MAX;
			double r2 = (double)rand()/RAND_MAX;
			double n_rand = deviation*sqrt(-2*log(r1))*cos(2*M_PI*r2) + mean;
			double newweight = genes[i]+n_rand;
			if(newweight <= DBL_MAX && newweight >= -DBL_MAX)
			{
				
				genes[i] += n_rand;
			}
		}
	}
}
int chromosome::getID()
{
	return id;
}
