//#include "StdAfx.h"
#include "Layer.h"
#include <string>

Layer::Layer(void)
{
}
Layer::Layer(int numNeurons, int layernum)
{
	for(int i = 0; i < numNeurons; i++)
	{
		//printf("%i %i ", layernum, i);
		
		Neuron neuron(layernum, i, 0.0);
		neurons.push_back(neuron);
	}
}
Layer::~Layer(void)
{
}
vector<Neuron> Layer::getNeurons()
{
	return neurons;
}
void Layer::setNeurons(vector<double> in, int numin)
{
	for(int i = 0; i < numin; i++)
	{
		neurons[i].setActivation(in[i]);
		//printf("input for first layer: %f \n", neurons[i].getActivation());
	}
}
void Layer::setDeltas(std::vector<double> dif)
{
	for(int i = 0; i < dif.size(); i++)
	{
		neurons[i].setDelta(dif[i]);
	}
}
vector<double> Layer::getDeltas()
{
	vector<double> deltas;
	for(int i = 0; i < neurons.size(); i++)
	{
		deltas.push_back(neurons[i].getDelta());
	}
	return deltas;
}
void Layer::clearInputs()
{
	for(int i = 0; i < neurons.size(); i++)
	{
		neurons[i].setInput(0.0);
	}
}