//#include "StdAfx.h"
#include "Link.h"

Link::Link(void)
{
}
Link::Link(Layer &new_pre, Layer &new_post)
{
	pre = new_pre;
	post = new_post;
	
	//printf("%i.%i ", pre.neurons[0].layer, pre.neurons[0].id);
	//printf("%i.%i \n", post.neurons[0].layer, post.neurons[0].id);

	for(int i = 0; i < pre.neurons.size(); i++)
	{
		for(int j = 0; j < post.neurons.size(); j++)
		{	//printf("creating new arc between %d and %d \n", i, j);
			Arc arc(pre.neurons[i], post.neurons[j]);
			//printf("%f.%f ", pre.neurons[i].getActivation(), pre.neurons[i].id);
			//printf("%i.%i \n", post.neurons[j].layer, post.neurons[j].id);
			arcs.push_back(arc);
			//postNeurons[j].inncoming.push_back(arc);
		}
	}
}
Link::~Link(void)
{
}
void Link::activate()
{
	
	post.clearInputs();

	for(int i = 0; i < arcs.size(); i++)
	{
		//double in = pre.neurons[i % pre.neurons.size()].getActivation();
		double preindex = (i * pre.neurons.size()) / arcs.size()  /*i%pre.neurons.size()*/;
		//printf("pre: %f \n", preindex);
		double in = pre.neurons[preindex].getActivation();
		double w = arcs[i].getWeight();
		//printf("%f input  %f weight \n", in, w);
		int postindex = i % post.neurons.size();
		//printf("%i postindex \n", postindex);
		post.neurons[postindex].addInput(in* w);
		//post.neurons[postindex].activate();
		//printf("%f input value to activate\n", post.neurons[postindex].getInput());
	}
	for(int i = 0; i < post.getNeurons().size(); i++)
	{
		post.neurons[i].activate();
	}
}
Layer Link::getPreLayer()
{
	return pre;
}
void Link::backPropagate(double beta)
{	
	for(int i = 0; i < pre.neurons.size(); i++)
	{
		double output = pre.neurons[i].getActivation();
		//printf("output: %f \n", output);
		double delta = output * (1 - output);
		//printf("Delta for faen: %f \n", delta);
		double prevDeltas = 0.0;
		vector<double> weights = getWeightsFrom(pre.neurons[i]);
		for(int j = 0; j < post.neurons.size(); j++)
		{
			prevDeltas += post.neurons[j].getDelta() * weights[j];
		}
		//printf("prevDelta: %f\n Beta: %f", prevDeltas, beta);
		pre.neurons[i].setDelta(delta*prevDeltas);
		//system("PAUSE");
		for(int j = 0; j < post.neurons.size(); j++)
		{
			weights[j] =  beta * output * post.neurons[j].getDelta();
			//printf("weightChange: %f \n", beta * output * prevDeltas);
		}
		int k = 0;
		for(int j = 0; j < arcs.size(); j++)
		{
			if(arcs[j].getPre().id == pre.neurons[i].id)
			{
				double weight = arcs[j].getWeight();
				//printf("lastchange: %f  %f \n", weight , weight + weights[k] + 0.1 * arcs[j].getLastChange());
				arcs[j].setWeight(weight + weights[k] + 0.01 * arcs[j].getLastChange());
				arcs[j].setLastChange(weights[k] + 0.1 * arcs[j].getLastChange());
				//printf("test: %f  %f \n", weight , weights[k]);
				k++;
			}
		}
	}
}
vector<double> Link::getWeightsFrom(Neuron from)
{
	vector<double> weights;
	for(int i = 0; i < arcs.size(); i++)
	{
		if(arcs[i].getPre().id == from.id)
		{
			weights.push_back(arcs[i].getWeight());
		}
	}
	return weights;
}
void Link::setPostDeltas(std::vector<double> deltas)
{
	post.setDeltas(deltas);
}
