//#include "StdAfx.h"
#include "Network.h"
#define _USE_MATH_DEFINES
#include<math.h>

Network::Network(int New_numLayers, int *New_numNeurons)
{
	
	//srand((unsigned)time(NULL));
	numLayers = New_numLayers;
	numNeurons = New_numNeurons;
	//printf("%i ", numLayers);
	
	for(int i = 0; i < numLayers; i++)
	{
		Layer l(numNeurons[i], i);
		layers.push_back(l);
	}
	for(int i = 0; i < numLayers-1; i++)
	{
		Link l(layers[i], layers[i+1]);
		//printf("%i.%i ", layers[i].neurons[0].layer, layers[i].neurons[0].id);
		//printf("%i.%i \n", layers[i+1].neurons[0].layer, layers[i+1].neurons[0].id);
		links.push_back(l);
	}

}

Network::~Network(void)
{
}
void Network::activate(std::vector<double> inputs, int numInputs)
{
	links.front().pre.setNeurons(inputs, numInputs);

	for(int i = 0; i < links.size(); i++)
	{
		//printf("%i \n", links.size());
		links[i].activate();
		if(i < links.size()-1)
		{
			links[i+1].pre = links[i].post;
		}
	}
	
}
vector<Layer> Network::getLayers()
{
	return layers;
}
void Network::backProp(std::vector<double> input, std::vector<double> output, int numEx, double alpha, double beta)
{	
	
	int inputPerEx = input.size() / numEx;
	int outputPerEx = output.size() / numEx;
	double error = 0.0;
	int backpropcount = 0;
	do 
	{
		error = 0.0;
		for(int i = 0; i < numEx; i++)
			{
				vector<double> tempIn(input.begin()+ (i * inputPerEx), input.begin()+ (i * inputPerEx) + inputPerEx);
				vector<double> tempOut(output.begin()+ (i * outputPerEx), output.begin()+ (i * outputPerEx) + outputPerEx);
				activate(tempIn, inputPerEx);
				vector<double> res = getResults();
				vector<double> dif;
				dif.clear();
				if(tempOut[0] == 0)
				{
					if(res[0] < 0.1)
					{
						res[0] = 0;
					}
					res[1] = 0;
					res[2] = 0;
					if(res[3] > 0.9 && res[4] < 0.1 && res[5] < 0.1)
					{
						res[3] = 1;
						res[4] = 0;
						res[5] = 0;
					}
					else if(res[4] > 0.9 && res[3] < 0.1 && res[5] < 0.1)
					{
						res[3] = 0;
						res[4] = 1;
						res[5] = 0;
					}
					else if(res[5] > 0.9 && res[3] < 0.1 && res[4] < 0.1)
					{
						res[3] = 0;
						res[4] = 0;
						res[5] = 1;
					}
				}
				else if(tempOut[0] == 1)
				{
					if(res[0] > 0.9)
					{
						res[0] = 1;
					}
					res[3] = 0;
					res[4] = 0;
					res[5] = 0;
				}

				for(int j = 0; j < res.size(); j++)
				{

					//printf("results: wanted %f result %f \n", tempOut[j], res[j]);
					double temperror = abs((tempOut[j] - res[j]));
					double delta = (tempOut[j] - res[j])*res[j]*(1-res[j]);
					dif.push_back(delta);
					//printf("temperror: %f \n delta: %f \n", temperror, delta);
					error += temperror*temperror;
					
				}
				links.back().setPostDeltas(dif);
			
				
				backProp(beta);
				dif.clear();
				
				/*for(int j = links.size()-1; j >= 0; j--)
				{	
				printf("weight: %f \n", links[j].arcs[0].getWeight());
				}*/
		}
		backpropcount++;
		error = error/numEx;
		printf("%f < %f  %i\n", error, alpha, backpropcount);
	}while(error > alpha && backpropcount < 500);
}
vector<double> Network::getResults()
{	
	vector<Neuron> n = (links.back().post.getNeurons());
	vector<double> results;
	for(int i = 0; i < n.size(); i++)
	{
		results.push_back((double)n[i].getActivation());
		//printf("activation: %f \n", (double)n[i].getActivation());
	} 

	return results;
}
void Network::changeWeights(std::vector<double> new_weights)
{	
	vector<int> numArcsPerLink;
	for(int i = 0; i < links.size(); i++)
	{
		numArcsPerLink.push_back(links[i].arcs.size());
	}
	int k = 0;
	for(int i = 0; i < links.size(); i++)
	{
		for(int j = 0; j < numArcsPerLink[i]; j++)
		{
			links[i].arcs[j].setWeight(new_weights[k]);
			k++;
		}
	}
}
void Network::backProp(double beta)
{	
	//printf("backprop");
	for(int i = links.size()- 1; i >= 0; i--)
	{
		links[i].backPropagate(beta);
		
		if(!(i == 0)){
			links[i-1].setPostDeltas(links[i].getPreLayer().getDeltas());

		}
	}
	
}
vector< vector<double> > Network::getWeights()
{
	vector< vector<double> > weights;
	vector<double> linkWeight;
	for(int i = 0; i < links.size(); i++)
	{
		for(int j = 0; j < links[i].arcs.size(); j++)
		{
			double weight = links[i].arcs[j].getWeight();
			linkWeight.push_back(weight);
		}
		weights.push_back(linkWeight);
		linkWeight.clear();
	}
	return weights;
}